'------------------------------------------------------------------------
'------------------------------------------------------------------------
'------------------------------------------------------------------------
'---                      Fetch_Image.vbs (v2.21)                     ---
'---                       - Fetch_Image - v2.21                      ---
'---                                                                  ---
'---                         -- Author: ViX --                        ---
'---                please keep the strips still coming               ---
'---                                                                  ---
'---                       ViX @ Samurize forum                       ---
'---           ViX @ news:finet.binaries.keskustelu.samurize          ---
'------------------------------------------------------------------------
'------------------------------------------------------------------------
'------------------------------------------------------------------------
'
'        Usage:
'        ------
'
'        Read ReadMe :)
'
'------------------------------------------------------------------------
'
'  History:
'  --------
'
'  15.2.2004  - Fetch_Image - v1.0
'                 *Initial release
'
'  16.2.2004  - Fetch_Image - v1.01
'                 *Fixed bug
'                 *Fixed BIG bug in Looppi (iltalehti)
'                 *Added features
'                  +You can make meter-Linkage to open it in Internet Explorer
'
'  24.4.2004  - Fetch_Image - v2.0
'                 *Rewritten
'                  +Jaap's ideas was GREAT
'
'  1.5.2004   - Fetch_Image - v2.01
'                 *Moved features to .xml:
'                  +Delete old files
'                   True / False  --> Frees some space / Collect all
'                  +Link to file
'                   True / False  --> Open file in Internet
'                                     Explorer when clicked
'                                     requires:
'                                      Meter-linkage in config
'                  +expiry time in mins
'                   I think this is quite self-explained :)
'                   for ex.
'                    0    = Load image every time --> WebCam
'                    1440 = 24 hours              --> Comics etc.
'                  +Error.png
'                  +http://www.durhamstudents.co.uk/samurize/vix/Fetch_Image.xls
'                    I made a simple excel table of now available strips.
'                    Run macro to get prober .xml-file.
'                    (Tested with Office XP)
'
'                    !!!Check link sometimes for new strips!!!
'
'
'  3.5.2004   - Fetch_Image - v2.02
'                 *Fixed bug in error handling
'
'  11.5.2004  - Fetch_Image - v2.05
'                 *walkersc found a BIG bug
'                 *romrom found a BIG bug
'
'  4.7.2004   - Fetch_Image - v2.1
'                 *Fixed bug in cached images
'                  -Thanks to nuetz for reporting
'                 *tempname-parameter
'                  -LimDuls idea
'                  -Fixes images without path (for ex. UD-stats)
'                  -Better support for slideshow-plugin
'                  -%Y,%y (year)
'                  -%M,%m (month)
'                  -%D,%d (day)
'                  -%H (hour)
'                  -%N (minute)
'                 *Now you need to define a XML file
'                  (support for mutiple xml file)
'                  (Theres too much stuff for one .xml-file)
'                  -LimDuls idea & code-parts
'                 *Random_Image()-function
'
'  25.7.2004  - Fetch_Image - v2.15
'                 *Fixes added
'                 *Updates added
'                  (So nothing extremely special)
'
'  27.7.2004  - Fetch_Image - v2.16
'                 *ReturnBinary Rewritten to follow redirects
'
'  14.8.2004  - Fetch_Image - v2.17
'                 *I learned how to use Multiline in correct way 
'                  (look weather.xml and aussichten 4 for example)
'
'  18.8.2004  - Fetch_Image - v2.2
'                 *Final release
'                  -I think this is now ready :)
'                  -I'm starting to write this rhing into plugin
'                 *Added some error handling things
'                 *Fixes added
'
'  16.9.2004  - Fetch_Image - v2.21
'                 *%W,%w (week)
'
'------------------------------------------------------------------------
'------------------------------------------------------------------------
'------------------------------------------------------------------------
'
'    In case you have problems, check the link for simple how-to-quide
'     http://www.samurize.com/modules/ipboard/index.php?showtopic=3139
'
'          After reading it through feel free to send PM to me.
'                        I'll be clad to help
'
'------------------------------------------------------------------------
'------------------------------------------------------------------------
'------------------------------------------------------------------------


'------------------------------------------------------------------------
'----------------- Do not touch from this point forward -----------------
'------------------------------------------------------------------------

Function Fetch_Image(Image, XmlFile)

    If XmlFile = "" Then
        XmlFile = "Fetch Image"
    End If

    If Image = "" Then
        Image = Random_Image(XmlFile)
    End If

' Get image URL and other properties
    Dim objXML

    Set objXML = CreateObject("Microsoft.XMLDOM")
    objXML.async = False
    objXML.LoadXML (ReadXML(XmlFile))
    If (objXML.parseError.errorCode <> 0) Then
        Fetch_Image = "XML error %b Error Line: " & objXML.parseError.Line & _
                                "%b Error Code: " & objXML.parseError.errorCode & _
                                "%b Error Reason: " & objXML.parseError.reason
        Set objXML = Nothing
        Exit Function
    End If

    Dim YearLong, YearShort, MonthLong, MonthShort, WeekLong, WeekShort, DayLong, DayShort, HourLong, MinuteLong

    YearLong = Year(Date)
    YearShort = Right(YearLong, 2)
    
    MonthShort = Month(Date)
    If (MonthShort < 10) Then
        MonthLong = "0" & MonthShort
    Else
        MonthLong = MonthShort
    End If

	WeekShort = DatePart("ww", Now() ,0 , 0)
    If (WeekShort < 10) Then
        WeekLong = "0" & WeekShort
    Else
        WeekLong = WeekShort
    End If
	
    DayShort = Day(Date)
    If (DayShort < 10) Then
        DayLong = "0" & DayShort
    Else
        DayLong = DayShort
    End If

    HourLong = Hour(Now)
    If (HourLong < 10) Then
        HourLong = "0" & HourLong
    End If

    MinuteLong = Minute(Now)
    If (MinuteLong < 10) Then
        MinuteLong = "0" & MinuteLong
    End If

' Solve image URL
    Dim HtmlError, REError
	HtmlError = False
	REError = False

    Dim ComicXML, ma
    Dim HTML, URL
    Dim Link_to_File, Delete_Old_Files, ExpiryTimeInMins

    Set ComicXML = objXML.selectSingleNode("/Fetch_Image/strip[@name='" & Image & "']")
    Set objXML = Nothing
    Link_to_File = CBool(LCase(ComicXML.selectSingleNode("./meter_linkage").Text) = "true")
    Delete_Old_Files = CBool(LCase(ComicXML.selectSingleNode("./delete_old").Text) = "true")
    ExpiryTimeInMins = CLng(ComicXML.selectSingleNode("./expiry_time").Text)
    If (ComicXML.selectSingleNode("./imageurl") Is Nothing) Then
        Dim objRE
        Set objRE = New RegExp
        objRE.Pattern = Replace(ComicXML.selectSingleNode("./searchpattern").Text, "%amp;", "&")
        objRE.Global = True 'False
        objRE.IgnoreCase = True
        objRE.Multiline = True
        URL = Replace(ComicXML.selectSingleNode("./homepage").Text, "%amp;", "&")
        HTML = ReturnHTML(URL)
        If HTML <> False Then
            If objRE.Test(HTML) Then
                Set ma = objRE.Execute(HTML)
                URL = Replace(ComicXML.selectSingleNode("./imagebaseurl").Text, "%amp;", "&")
                URL = URL & ma(0).SubMatches(0)
            Else
                URL = False
                REError = True
            End If
        Else
            URL = False
            HtmlError = True
        End If
        Set objRE = Nothing
    Else
        URL = Replace(ComicXML.selectSingleNode("./imageurl").Text, "%amp;", "&")

        URL = Replace(URL, "%Y", YearLong)
        URL = Replace(URL, "%y", YearShort)
        URL = Replace(URL, "%M", MonthLong)
        URL = Replace(URL, "%m", MonthShort)
        URL = Replace(URL, "%W", WeekLong)
        URL = Replace(URL, "%w", WeekShort)
        URL = Replace(URL, "%D", DayLong)
        URL = Replace(URL, "%d", DayShort)
        URL = Replace(URL, "%H", HourLong)
        URL = Replace(URL, "%N", MinuteLong)
    End If

    If (URL <> False) Then
        Dim fso
        Set fso = CreateObject("Scripting.FileSystemObject")
        Dim str_TempImg, str_TempPath
        Dim int_End

    ' Tempimage name
    ' Path to TEMP folder
        str_TempPath = fso.GetSpecialFolder(2) & "\SamurizeTemp\" & Image & "\"
        If (ComicXML.selectSingleNode("./tempname") Is Nothing) Then
        ' Parse filename from URL
            int_End = InStrRev(URL, "/", -1)
            str_TempImg = Right(URL, Len(URL) - int_End)
            str_TempImg = str_TempPath & str_TempImg
        Else
        ' Path to TEMP folder & desired filename
            str_TempImg = ComicXML.selectSingleNode("./tempname").Text
            str_TempImg = Replace(str_TempImg, "%TempPath\", str_TempPath)
        ' Create name from current date
            str_TempImg = Replace(str_TempImg, "%Y", YearLong)
            str_TempImg = Replace(str_TempImg, "%y", YearShort)
            str_TempImg = Replace(str_TempImg, "%M", MonthLong)
            str_TempImg = Replace(str_TempImg, "%m", MonthShort)
            str_TempImg = Replace(str_TempImg, "%W", WeekLong)
            str_TempImg = Replace(str_TempImg, "%w", WeekShort)
            str_TempImg = Replace(str_TempImg, "%D", DayLong)
            str_TempImg = Replace(str_TempImg, "%d", DayShort)
            str_TempImg = Replace(str_TempImg, "%H", HourLong)
            str_TempImg = Replace(str_TempImg, "%N", MinuteLong)

        ' In case you've given your own path
            str_TempPath = Left(str_TempImg, InStrRev(str_TempImg, "\", -1))
        End If

        int_End = 1
        While int_End <= Len(str_TempPath)
            int_End = InStr(int_End, str_TempImg, "\")
            str_TempPathFolder = Left(str_TempImg, int_End)
            If Not fso.FolderExists(str_TempPathFolder) Then
                fso.CreateFolder (str_TempPathFolder)
            End If
            int_End = int_End + 1
        Wend

    ' Delete old files --> Frees some space
        If Len(str_TempPath) <= 3 Then
        ' don't delete old files if your image dowloaded to root of drive
            Delete_Old_Files = False
        End If
        If Delete_Old_Files Then
            Dim f1, fc, f
            Set f = fso.GetFolder(str_TempPath)
            Set fc = f.Files
            For Each f1 In fc
                If f1 <> str_TempImg Then
                    fso.DeleteFile (f1)
                End If
            Next
            Set f1 = Nothing
            Set fc = Nothing
        End If

        Dim Fetch
        Fetch = False
        Dim Last_Fetched
        Last_Fetched = TimeDiff(str_TempImg)
        If (Last_Fetched >= ExpiryTimeInMins Or Last_Fetched < 0) Then
        ' Old file --> Get a new one
            Fetch = True
        End If

        If Fetch Then
            Dim OK
            OK = ReturnBinary(URL, str_TempImg)
        ' For (RegExp) DeBugging
        '    Fetch_Image = URL
        '    Exit Function
        End If

        If OK And Fetch Then
        ' Image downloaded was succesfully
            Fetch_Image = str_TempImg
        ElseIf Not OK And Fetch Then
        ' Image download was UNsuccesfull --> find out why
            Fetch_Image = SamurizePath & "dl error.png"
        Else
        ' Image was up to date --> No need to download
            Fetch_Image = str_TempImg
        End If

        Set fso = Nothing
    End If

    Set ComicXML = Nothing

' Images URL could not be created or RegExp is corrupted
    If REError Then
        Fetch_Image = SamurizePath & "regexp error.png"
        Exit Function
    End If

    If HtmlError Then
        Fetch_Image = SamurizePath & "html error.png"
        Exit Function
    End If

    If Link_to_File Then
        Fetch_Image = Fetch_Image & "%lexplorer.exe " & Fetch_Image
    End If
End Function

Function Random_Image(XmlFile)
    Set objXML = CreateObject("Microsoft.XMLDOM")
    objXML.async = False
    objXML.LoadXML (ReadXML(XmlFile))

    If (objXML.parseError.errorCode <> 0) Then
        Random_Image = "XML error %b Error Line: " & objXML.parseError.Line & _
                                 "%b Error Code: " & objXML.parseError.errorCode & _
                                 "%b Error Reason: " & objXML.parseError.reason
        Set objXML = Nothing
        Exit Function
    End If

    Set MyNodeList = objXML.selectNodes("/Fetch_Image/strip/@name")
    Set objXML = Nothing

    Dim X
    Randomize   ' Initialize random-number generator.
    X = Int(Rnd * MyNodeList.Length)

    Random_Image = Fetch_Image(MyNodeList.Item(X).Value, XmlFile)
    Set MyNodeList = Nothing
End Function

Private Function ReadXML(XmlFile)
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set f = fso.GetFile(SamurizePath & XmlFile & ".xml")
    ReadXML = f.OpenAsTextStream(1, -2).readall
    ReadXML = Replace(ReadXML, "&", "%amp;")
    Set fso = Nothing
    Set f = Nothing
End Function

Private Function ReturnHTML(URL)
    Dim objXMLHTTP, HTML
    Set objXMLHTTP = CreateObject("MSXML2.ServerXMLHTTP")
    On Error Resume Next
    objXMLHTTP.Open "GET", URL, False
    objXMLHTTP.Send
    If Err = 0 And objXMLHTTP.Status = 200 Then
        HTML = objXMLHTTP.responseBody
        Set objRS = CreateObject("ADODB.Recordset")
        objRS.Fields.Append "txt", 200, 35000, &H80
        objRS.Open
        objRS.AddNew
        objRS.Fields("txt").AppendChunk HTML
        ReturnHTML = objRS("txt").Value
        objRS.Close
        Set objRS = Nothing
    Else
        ReturnHTML = False
    End If
    On Error GoTo 0
    Set objXMLHTTP = Nothing
End Function

Private Function ReturnBinary(sURL, IMGTemp)
'Uses the Microsoft WinHttp 5.1 object included with:
'Windows 2000 SP3, Windows XP SP1, Windows Server 2003
'Falls back to using the older 5.0 object if available.

' Used to avoid getting cached images
'    Randomize   ' Initialize random-number generator.
'    sURL = sURL & "?" & Int((Rnd * 100000))

    Dim HTTP
    Const HTTPREQUEST_SETCREDENTIALS_FOR_SERVER = 0
    Const HTTPREQUEST_SETCREDENTIALS_FOR_PROXY = 1
    Const WinHttpRequestOption_UserAgentString = 0
    Const WinHttpRequestOption_EscapePercentInURL = 3
    Const WinHttpRequestOption_EnableRedirects = 6
    Const WinHttpRequestOption_UrlEscapeDisable = 7
    Const WinHttpRequestOption_UrlEscapeDisableQuery = 8

    Set HTTP = Nothing
    On Error Resume Next
    Set HTTP = CreateObject("WinHttp.WinHttpRequest.5.1")
    On Error Resume Next
    If HTTP Is Nothing Then
        Set HTTP = CreateObject("WinHttp.WinHttpRequest.5")
    End If
    HTTP.Option(WinHttpRequestOption_EnableRedirects) = True
    HTTP.Open "GET", sURL, False
'''''''''
'    Can use below text if needed to log in to server
'    HTTP.SetCredentials(strUserName, strPassword, HTTPREQUEST_SETCREDENTIALS_FOR_SERVER)
'''''''''
'''''''''
'    Could also use the below commented text to get all or specific header
'    HTTP.Open "HEAD", strURL, False
'    HTTP.Send
'    GetData = HTTP.GetResponseHeader("Set-Cookie")
'    GetData = HTTP.GetAllResponseHeaders
'''''''''
'''''''''
'    Can use the below code to set a custom header
'    HTTP.SetRequestHeader "Cookie", "username=foo"
'''''''''
'''''''''
'    Can use below text to POST data to a server
'    HTTP.Open "PUT", strURL, False
'    HTTP.Send "username=foo&password=bar"
'''''''''

    HTTP.Send
    If Err = 0 And HTTP.Status = "200" Then
        ' Save image to disc
        Set Stream = CreateObject("adodb.stream")
        Const adTypeBinary = 1
        Const adSaveCreateNotExist = 1
        Const adSaveCreateOverWrite = 2
        Stream.Type = adTypeBinary
        Stream.Open
        Stream.write HTTP.responseBody
        Stream.SaveToFile IMGTemp, adSaveCreateOverWrite
        Set Stream = Nothing
        ReturnBinary = True
    Else
        ReturnBinary = False
    End If
End Function

Private Function TimeDiff(FileName)
    Dim fso, f
    Dim diff
    Set fso = CreateObject("Scripting.FileSystemObject")
    If fso.FileExists(FileName) Then
        Set f = fso.GetFile(FileName)
        TimeDiff = DateDiff("n", f.DateLastModified, Now)
    Else
        TimeDiff = -1
    End If
    Set f = Nothing
    Set fso = Nothing
End Function

Private Function SamurizePath()
'Path to Samurize folder
    SamurizePath = CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")
End Function
